#!/usr/bin/env tclsh

# Rechentrainer 1.0
# Oliver Scholl
# Copyright 2013
# 
# Lizenz:
# Das Programm steht unter der GPL, Version 2
#
# Programmbeschreibung:
# Das Programm dient zum Üben von Grundrechenaufgaben.
# Nach Eingabe des Aufgabentyps (plus, minus, mal), des
# Zahlenraums und der Anzahl der Übungsaufgaben, stellt 
# das Programm die Rechenaufgaben. Der Anwender soll die
# Lösung eingeben. Das Programm prüft die Lösung und
# zählt, wie viele Aufgaben richtig oder falsch gelöst
# wurden.
#
# Globale Variablen:
# Aufgabe : Art der Aufgabe (1=plus, 2=minus, 3=mal)
# Zahlenraum : Größtmögliche Zahl, die in der Aufgabe vorkommt
# Anzahl : Anzahl der Aufgaben, die geübt werden sollen
# Richtig : Anzahl der richtig gelösten Aufgaben
# Falsch : Anzahl der falsch gelösten Aufgaben
# Zahl1 : Zahl in der Rechenaufgabe
# Zahl2 : Zahl in der Rechenaufgabe
# Ergebnis : Ergebnis der Rechenaufgabe
# Loesung : Lösung der Rechenaufgabe. Eingabe durch den Benutzer.
# Wurzel : Hilfszahl, um die Rechenaufgabe zu erstellen

# Zufallszahl erzeugen
expr srand(int([clock seconds]))

puts "Rechentrainer"

set Aufgabe 0
while {$Aufgabe < 1 || $Aufgabe > 4} {
puts "Es gibt folgende Rechenaufgaben:"
puts "(1) plus"
puts "(2) minus"
puts "(3) mal"
puts "(4) Programm beenden"
puts "Bitte wähle eine Rechenaufgabe 1 bis 3:"
set Aufgabe [gets stdin]
}

if {$Aufgabe == 4} {
  exit ; # Das Programm wird beendet
}

puts "Bitte gib den Zahlenraum ein (z.B. bis 10):"
set Zahlenraum [gets stdin]

puts "Wieviele Aufgaben möchtest du üben?"
set Anzahl [gets stdin]

set Richtig 0 ; # zählt, wie oft richtig gerechnet wurde
set Falsch 0 ; # zählt, wie oft falsch gerechnet
while {$Anzahl > 0} {
  incr Anzahl -1 ; # zählt die Anzahl der Aufgaben rückwärts bis Null
  switch $Aufgabe {
  1 {
      # Plus-Aufgabe
      set Ergebnis [expr int(($Zahlenraum+1)*rand())]
      set Zahl1 [expr int(($Ergebnis+1)*rand())]
      set Zahl2 [expr $Ergebnis - $Zahl1]
      
      puts "$Zahl1 + $Zahl2 = ?"
      set Loesung [gets stdin]
      
      if {$Loesung == $Ergebnis} {
        incr Richtig
      } else {
      incr Falsch
      }
    }
  2 {
      # Minus-Aufgabe
      set Zahl1 [expr int(($Zahlenraum+1)*rand())]
      set Zahl2 [expr int(($Zahl1+1)*rand())]
      set Ergebnis [expr $Zahl1 - $Zahl2]
      
      puts "$Zahl1 - $Zahl2 = ?"
      set Loesung [gets stdin]
      
      if {$Loesung == $Ergebnis} {
        incr Richtig
      } else {
        incr Falsch
      }
    }
  3 {
      # Mal-Aufgabe
      set Wurzel [expr sqrt($Zahlenraum)]
      set Zahl1 [expr int(($Wurzel+1)*rand())]
      set Zahl2 [expr int($Wurzel*rand())]
      set Ergebnis [expr $Zahl1 * $Zahl2]
      
      puts "$Zahl1 * $Zahl2 = ?"
      set Loesung [gets stdin]
      
      if {$Loesung == $Ergebnis} {
        incr Richtig
      } else {
        incr Falsch
      }
    }
  }
}
puts "Du hast $Richtig Aufgabe(n) richtig gelöst. $Falsch Aufgabe(n) waren falsch."
