#!/usr/bin/env wish

proc Drehen {Liste Grad DPx DPy} {
  # Liste = Liste der Eckpunkt des Polygons
  # Grad = Drehwinkel (0 bis 360 Grad), entgegen dem Uhrzeigersinn
  # DPx = x-Koordinate des Drehpunkts
  # DPy = y-Koordinate des Drehpunkts

  # Rueckgabe: Liste der transformierten Eckpunkte

  set Pi 3.1415926535897931
  set Grad2 [expr $Grad/180.0*$Pi]

  set ListeGedreht {}
  foreach {x y} $Liste {
    set x2 [expr $x-$DPx]
    set y2 [expr $y-$DPy]
    lappend ListeGedreht [expr round($x2 * cos($Grad2) + $y2 * sin($Grad2))+$DPx]
    lappend ListeGedreht [expr round(-$x2 * sin($Grad2) + $y2 * cos($Grad2))+$DPy]
  }
  return $ListeGedreht
}

canvas .c -width 200 -height 100
pack .c

set Linie1 [.c create line 95 50 105 50 -width 1 -fill red] ; # Drehpunkt
set Linie2 [.c create line 100 45 100 55 -width 1 -fill red] ; # Drehpunkt
set ListePunkte {}
set ListePunkte [list 75 25 125 25 125 75 75 75]

set Polygon [.c create polygon $ListePunkte -width 1 -outline blue -fill ""]
for {set i 0} {$i <=360} {incr i} {
  set Grad $i
  set ListePunkteGedreht [Drehen $ListePunkte $Grad 100 50]
  .c coords $Polygon $ListePunkteGedreht
  update idletasks
  after 10
}
