#!/usr/bin/env wish

set xMin -6
set xMax 8
set yMin -5
set yMax 10

set pid [open "| gnuplot" "w"]	
puts $pid "set terminal png enhanced truecolor size 600, 300"
puts $pid "set output 'Grafik.png'"
puts $pid "set ytics 1"
puts $pid "set xtics 1"
puts $pid "set grid ytics xtics"
puts $pid "set xrange\[$xMin:$xMax\]"
puts $pid "set yrange\[$yMin:$yMax\]"
puts $pid "set grid"
puts $pid "plot 4*sin(x) notitle,2*x+0.5 notitle,x*x-3 notitle"
close $pid

ttk::frame .fr
canvas .fr.c -width 300 -height 150 -xscrollcommand ".fr.xscroll set" -yscrollcommand ".fr.yscroll set"

image create photo Bild -file Grafik.png

.fr.c create image 0 0 -anchor nw -image Bild
.fr.c configure -scrollregion [.fr.c bbox all]
ttk::scrollbar .fr.xscroll -orient horizontal -command ".fr.c xview"
ttk::scrollbar .fr.yscroll -command ".fr.c yview"
pack .fr.xscroll -side bottom -fill x
pack .fr.yscroll -side right -fill y
pack .fr.c -expand yes -fill both -side top
pack .fr -expand yes -fill both -side top
