#!/usr/bin/env wish

set Konf(Skriptname) [info script]
if {[file type $Konf(Skriptname)] == "link"} {
  set Konf(Skriptname) [file readlink $Konf(Skriptname)]
}
::msgcat::mclocale de ;# Alternative Sprachen: de=deutsch en=englisch
::msgcat::mcload [file join [file dirname $Konf(Skriptname)]]

proc SpracheAendern {Sprache} {
  global Konf

  switch $Sprache {
    Deutsch {::msgcat::mclocale de}
    English {::msgcat::mclocale en}
  }
  ::msgcat::mcload [file join [file dirname $Konf(Skriptname)]]

  .lbDatei configure -text [::msgcat::mc "Datei:"]
  .btEnde configure -text [::msgcat::mc "Schliessen"]

  .m entryconfigure 0 -label [::msgcat::mc "Schliessen"]
  .m entryconfigure 1 -label [::msgcat::mc "Sprache"]
  .m entryconfigure 2 -label [::msgcat::mc "Info"]

  update idletasks
}

set Sprache "Deutsch"
set Datei ""

option add *Menu.tearOff 0
. configure -menu .m
menu .m
.m add command -label [::msgcat::mc "Schliessen"] -command exit
.m add cascade -label [::msgcat::mc "Sprache"] -menu .m.sprache
.m add command -label [::msgcat::mc "Info"] -command exit

menu .m.sprache
.m.sprache add radiobutton -label "Deutsch" -variable Sprache -command {SpracheAendern $Sprache}
.m.sprache add radiobutton -label "English" -variable Sprache -command {SpracheAendern $Sprache}

ttk::label .lbDatei -text [::msgcat::mc "Datei:"]
ttk::entry .enDatei -textvariable Datei
ttk::button .btEnde -text [::msgcat::mc "Schliessen"] -command exit

grid .lbDatei -row 0 -column 0
grid .enDatei -row 0 -column 1
grid .btEnde -row 1 -column 0 -columnspan 2
