#!/usr/bin/env wish

package require Tktable

ttk::frame .fr

table .fr.table \
  -rows 20 \
  -cols 10 \
  -titlerows 1 \
  -titlecols 1 \
  -height 5 \
  -width 25 \
  -rowheight 1 \
  -colwidth 10 \
  -maxheight 100 \
  -maxwidth 400 \
  -anchor c \
  -selectmode extended \
  -variable Wert \
  -xscrollcommand {.fr.xscroll set} \
  -yscrollcommand {.fr.yscroll set}
  
for {set Zeile 0} {$Zeile <= 19} {incr Zeile} {
  for {set Spalte 0} {$Spalte <= 9} {incr Spalte} {
    if {$Spalte == 0} {
      if {$Zeile > 0} {
        set Wert($Zeile,$Spalte) Zeile$Zeile
      }
    } else {
      if {$Zeile == 0} {
        set Wert($Zeile,$Spalte) Spalte$Spalte
      } else {
        set Wert($Zeile,$Spalte) $Zeile$Spalte
      }
    }
  }
}

.fr.table width 3 25

.fr.table tag col spalteA 3
.fr.table tag configure spalteA -anchor e
.fr.table tag configure spalteA -font {courier 18 bold}
.fr.table tag configure spalteA -background red
.fr.table tag configure spalteA -foreground blue

ttk::scrollbar .fr.xscroll -command {.fr.table xview} -orient horizontal
ttk::scrollbar .fr.yscroll -command {.fr.table yview}

pack .fr -fill both -expand 1
pack .fr.xscroll -side bottom -fill x
pack .fr.yscroll -side right -fill y
pack .fr.table -side right -fill both -expand 1
  

