#!/usr/bin/env wish

package require Tktable

proc Anzeigen {Tabelle} {
  global Tabelleninhalt
  
  puts "Zelle 1,2 hat den Wert $Tabelleninhalt(1,2)"

  set Index "1,3"
  set Wert [$Tabelle get $Index]
  puts "Zelle $Index hat den Wert $Wert"

  set Wert [$Tabelle get 1,4]
  puts "Zelle 1,4 hat den Wert $Wert"

  set LetzteSpalte [expr [$Tabelle cget -cols] -1]
  set Werte [$Tabelle get 1,0 1,$LetzteSpalte]
  puts "Zeile 1: $Werte"
  
  set LetzteZeile [expr [$Tabelle cget -rows] -1]
  set Werte [$Tabelle get 1,1 $LetzteZeile,1]
  puts "Spalte 1 ohne Titel: $Werte"
  puts "------------------------"
}

proc Aendern {Tabelle} {
  global Tabelleninhalt
  
  set Tabelleninhalt(1,2) "1/2"
  
  $Tabelle set 1,3 "1/3"

  $Tabelle set row 2,1 {"2/1" "2/2" "2/3"}

  set Liste {"3/0" "3/1" "3/2" "3/3" "3/4"}
  $Tabelle set row 3,0 $Liste

  $Tabelle set col 1,5 {"1/4" "2/4" "3/4" "4/4"}

  $Tabelle configure -rows 6
  $Tabelle set row 5,1 {"5/1" "5/2" "5/3"}
}

proc Einfuegen {Tabelle} {
  global Tabelleninhalt
  
  $Tabelle configure -rows 6
  $Tabelle set row 5,1 {"5/1" "5/2" "5/3"}

  $Tabelle configure -rows 7
  set Tabelleninhalt(6,0) "6/0"
  set Tabelleninhalt(6,1) "6/1"

  $Tabelle configure -cols 6
  $Tabelle set col 1,6 {"1/5" "2/5" "3/5" "4/5" "5/5" "6/5"}
}

ttk::frame .fr

table .fr.table \
  -rows 5 \
  -cols 5 \
  -titlerows 1 \
  -titlecols 0 \
  -height 5 \
  -width 25 \
  -rowheight 1 \
  -colwidth 9 \
  -maxheight 100 \
  -maxwidth 400 \
  -selectmode extended \
  -variable Tabelleninhalt \
  -xscrollcommand {.fr.xscroll set} \
  -yscrollcommand {.fr.yscroll set}
  
ttk::scrollbar .fr.xscroll -command {.fr.table xview} -orient horizontal
ttk::scrollbar .fr.yscroll -command {.fr.table yview}

ttk::button .btAnzeigen -text "Anzeigen" -command {Anzeigen .fr.table}
ttk::button .btAendern -text "Aendern" -command {Aendern .fr.table}
ttk::button .btEinfuegen -text "Einfuegen" -command {Einfuegen .fr.table}

pack .fr -fill both -expand 1
pack .fr.xscroll -side bottom -fill x
pack .fr.yscroll -side right -fill y
pack .fr.table -side right -fill both -expand 1
pack .btAnzeigen -side left
pack .btAendern -side left
pack .btEinfuegen -side left
  
for {set Zeile 0} {$Zeile <= 4} {incr Zeile} {
  for {set Spalte 0} {$Spalte <= 4} {incr Spalte} {
    if {$Zeile == 0} {
      set Tabelleninhalt($Zeile,$Spalte) Titel$Spalte
    } else {
      set Tabelleninhalt($Zeile,$Spalte) $Zeile$Spalte
    }
  }
}
