#!/usr/bin/env wish

package require Tktable

proc Metadaten {Tabelle} {
  set Index [$Tabelle curselection]
  set ErsterIndex [lindex $Index 0]
  set LetzterIndex [lindex $Index end]

  set tmp [split $ErsterIndex ","]
  set Zeile1 [lindex $tmp 0]
  set Spalte1 [lindex $tmp 1]

  set tmp [split $LetzterIndex ","]
  set Zeile2 [lindex $tmp 0]
  set Spalte2 [lindex $tmp 1]
  
  set SelektionAnzahlSpalten [expr $Spalte2 - $Spalte1 +1]
  set SelektionAnzahlZeilen [expr $Zeile2 - $Zeile1 +1]

  dict set TabMeta SelektionZeile1 $Zeile1
  dict set TabMeta SelektionSpalte1 $Spalte1
  dict set TabMeta SelektionZeile2 $Zeile2
  dict set TabMeta SelektionSpalte2 $Spalte2
  dict set TabMeta SelektionAnzahlZeilen $SelektionAnzahlZeilen
  dict set TabMeta SelektionAnzahlSpalten $SelektionAnzahlSpalten
  dict set TabMeta AnzahlZeilen [$Tabelle cget -rows]
  dict set TabMeta AnzahlSpalten [$Tabelle cget -cols]
  dict set TabMeta TitelAnzahlZeilen [$Tabelle cget -titlerows]
  dict set TabMeta TitelAnzahlSpalten [$Tabelle cget -titlecols]

  if {[dict get $TabMeta SelektionZeile1] == [dict get $TabMeta TitelAnzahlZeilen] && [dict get $TabMeta SelektionAnzahlZeilen] == [expr [dict get $TabMeta AnzahlZeilen] - [dict get $TabMeta TitelAnzahlZeilen]]} {
    dict set TabMeta GanzeSpalteMarkiert 1
  } else {
    dict set TabMeta GanzeSpalteMarkiert 0
  }

  if {[dict get $TabMeta SelektionSpalte1] == [dict get $TabMeta TitelAnzahlSpalten] && [dict get $TabMeta SelektionAnzahlSpalten] == [expr [dict get $TabMeta AnzahlSpalten] - [dict get $TabMeta TitelAnzahlSpalten]]} {
    dict set TabMeta GanzeZeileMarkiert 1
  } else {
    dict set TabMeta GanzeZeileMarkiert 0
  }

  return $TabMeta
}

proc ZeileEinfuegen {Tabelle Richtung} {
  # Richtung: 1 = unten / -1 = oben
  
  set TabMeta [Metadaten $Tabelle]
  if {[dict get $TabMeta GanzeZeileMarkiert] == 0} {return}

  if {$Richtung == 1} {
    set Zeile [dict get $TabMeta SelektionZeile2]
  } else {
    set Zeile [dict get $TabMeta SelektionZeile1]
  }
  set Anzahl [dict get $TabMeta SelektionAnzahlZeilen]
  set Anzahl [expr $Richtung * $Anzahl]
  if {$Zeile >= 0} {
    $Tabelle insert rows $Zeile $Anzahl
  }
}

proc SpalteEinfuegen {Tabelle Richtung} {
  # Richtung: 1 = rechts / -1 = links
  
  set TabMeta [Metadaten $Tabelle]
  if {[dict get $TabMeta GanzeSpalteMarkiert] == 0} {return}
  
  if {$Richtung == 1} {
    set Spalte [dict get $TabMeta SelektionSpalte2]
  } else {
    set Spalte [dict get $TabMeta SelektionSpalte1]
  }
  set Anzahl [dict get $TabMeta SelektionAnzahlSpalten]
  set Anzahl [expr $Richtung * $Anzahl]
  if {$Spalte >= 0} {
    $Tabelle insert cols $Spalte $Anzahl
  }
}

proc ZeileLoeschen {Tabelle} {
  set TabMeta [Metadaten $Tabelle]
  if {[dict get $TabMeta GanzeZeileMarkiert] == 0} {return}

  set Zeile [dict get $TabMeta SelektionZeile1]
  set Anzahl [dict get $TabMeta SelektionAnzahlZeilen]
  if {$Zeile >= 0} {
    $Tabelle delete rows $Zeile $Anzahl
  }
}

proc SpalteLoeschen {Tabelle} {
  set TabMeta [Metadaten $Tabelle]
  if {[dict get $TabMeta GanzeSpalteMarkiert] == 0} {return}

  set Spalte [dict get $TabMeta SelektionSpalte1]
  set Anzahl [dict get $TabMeta SelektionAnzahlSpalten]
  if {$Spalte >= 0} {
    $Tabelle delete cols $Spalte $Anzahl
  }
}

ttk::frame .fr
ttk::frame .fr2
ttk::frame .fr3

table .fr.table \
  -rows 20 \
  -cols 10 \
  -titlerows 1 \
  -titlecols 1 \
  -height 15 \
  -width 25 \
  -rowheight 1 \
  -colwidth 9 \
  -maxheight 400 \
  -maxwidth 600 \
  -selectmode extended \
  -variable Wert \
  -xscrollcommand {.fr.xscroll set} \
  -yscrollcommand {.fr.yscroll set}
  
scrollbar .fr.xscroll -command {.fr.table xview} -orient horizontal
scrollbar .fr.yscroll -command {.fr.table yview}

ttk::button .fr2.btZeileEinfuegenOben -text "Neue Zeile oben" -command {ZeileEinfuegen .fr.table -1}
ttk::button .fr2.btZeileEinfuegenUnten -text "Neue Zeile unten" -command {ZeileEinfuegen .fr.table 1}
ttk::button .fr2.btSpalteEinfuegenLinks -text "Neue Spalte links" -command {SpalteEinfuegen .fr.table -1}
ttk::button .fr2.btSpalteEinfuegenRechts -text "Neue Spalte rechts" -command {SpalteEinfuegen .fr.table 1}

ttk::button .fr3.btZeileLoeschen -text "Zeile loeschen" -command {ZeileLoeschen .fr.table}
ttk::button .fr3.btSpalteLoeschen -text "Spalte loeschen" -command {SpalteLoeschen .fr.table}

pack .fr -fill both -expand 1
pack .fr.xscroll -side bottom -fill x
pack .fr.yscroll -side right -fill y
pack .fr.table -side right -fill both -expand 1

pack .fr2 -anchor nw
pack .fr2.btZeileEinfuegenOben -side left
pack .fr2.btZeileEinfuegenUnten -side left
pack .fr2.btSpalteEinfuegenLinks -side left
pack .fr2.btSpalteEinfuegenRechts -side left

pack .fr3 -anchor nw
pack .fr3.btZeileLoeschen -side left
pack .fr3.btSpalteLoeschen -side left
  
for {set Zeile 0} {$Zeile <= 19} {incr Zeile} {
  for {set Spalte 0} {$Spalte <= 9} {incr Spalte} {
    if {$Spalte == 0} {
      if {$Zeile > 0} {
        set Wert($Zeile,$Spalte) Zeile$Zeile
      }
    } else {
      if {$Zeile == 0} {
        set Wert($Zeile,$Spalte) Spalte$Spalte
      } else {
        set Wert($Zeile,$Spalte) $Zeile$Spalte
      }
    }
  }
}
