#!/usr/bin/env wish

package require Tktable

proc ZeileEinfuegen {Tabelle Zeile Anzahl} {
  $Tabelle insert rows $Zeile $Anzahl
}

proc SpalteEinfuegen {Tabelle Spalte Anzahl} {
  $Tabelle insert cols $Spalte $Anzahl
}

proc ZeileLoeschen {Tabelle Zeile Anzahl} {
  $Tabelle delete rows $Zeile $Anzahl
}

proc SpalteLoeschen {Tabelle Spalte Anzahl} {
  $Tabelle delete cols $Spalte $Anzahl
}

ttk::frame .fr
ttk::frame .fr2
ttk::frame .fr3

table .fr.table \
  -rows 20 \
  -cols 10 \
  -titlerows 1 \
  -titlecols 1 \
  -height 15 \
  -width 25 \
  -rowheight 1 \
  -colwidth 9 \
  -maxheight 400 \
  -maxwidth 600 \
  -selectmode extended \
  -variable Wert \
  -xscrollcommand {.fr.xscroll set} \
  -yscrollcommand {.fr.yscroll set}
  
ttk::scrollbar .fr.xscroll -command {.fr.table xview} -orient horizontal
ttk::scrollbar .fr.yscroll -command {.fr.table yview}

ttk::button .fr2.btZeileEinfuegenOben -text "Neue Zeile oben" -command {ZeileEinfuegen .fr.table 1 -1}
ttk::button .fr2.btZeileEinfuegenUnten -text "Neue Zeile unten" -command {ZeileEinfuegen .fr.table 3 1}
ttk::button .fr2.btSpalteEinfuegenLinks -text "Neue Spalte links" -command {SpalteEinfuegen .fr.table 1 -1}
ttk::button .fr2.btSpalteEinfuegenRechts -text "Neue Spalte rechts" -command {SpalteEinfuegen .fr.table 3 1}

ttk::button .fr3.btZeileLoeschen -text "Zeile loeschen" -command {ZeileLoeschen .fr.table 1 1}
ttk::button .fr3.btSpalteLoeschen -text "Spalte loeschen" -command {SpalteLoeschen .fr.table 1 1}

pack .fr -fill both -expand 1
pack .fr.xscroll -side bottom -fill x
pack .fr.yscroll -side right -fill y
pack .fr.table -side right -fill both -expand 1

pack .fr2 -anchor nw
pack .fr2.btZeileEinfuegenOben -side left
pack .fr2.btZeileEinfuegenUnten -side left
pack .fr2.btSpalteEinfuegenLinks -side left
pack .fr2.btSpalteEinfuegenRechts -side left

pack .fr3 -anchor nw
pack .fr3.btZeileLoeschen -side left
pack .fr3.btSpalteLoeschen -side left
  
for {set Zeile 0} {$Zeile <= 19} {incr Zeile} {
  for {set Spalte 0} {$Spalte <= 9} {incr Spalte} {
    if {$Spalte == 0} {
      if {$Zeile > 0} {
        set Wert($Zeile,$Spalte) Zeile$Zeile
      }
    } else {
      if {$Zeile == 0} {
        set Wert($Zeile,$Spalte) Spalte$Spalte
      } else {
        set Wert($Zeile,$Spalte) $Zeile$Spalte
      }
    }
  }
}
