#!/usr/bin/env tclsh

oo::class create Verleihobjekt {
  puts "Variablen im Verleihobjekt"
  variable Titel
  variable Zustand
  variable Verleihstatus

  constructor {tmpTitel tmpZustand} {
    puts "Constructor im Verleihobjekt wird ausgefuehrt."
    set Titel $tmpTitel 
    set Zustand $tmpZustand
    set Verleihstatus "verfuegbar" 
  }

  method Anzeigen {} {
    puts "Anzeigen:"
    puts "Titel: $Titel, Zustand: $Zustand, Status: $Verleihstatus"
  }

  export Anzeigen
}

oo::class create Buchobjekt {
  superclass Verleihobjekt

  puts "Variablen aus der uebergeordneten Klasse verfuegbar machen:"
  variable Titel
  variable Zustand
  
  puts "Variablen im Buchobjekt"
  variable Autor
  variable ISBN
  
  constructor {tmpTitel tmpZustand tmpAutor tmpISBN} {
    next $tmpTitel $tmpZustand
    puts "Constructor im Buchobjekt wird ausgefuehrt."
    set Autor $tmpAutor
    set ISBN $tmpISBN
  }
  
  method BuchAnzeigen1 {} {
    puts "BuchAnzeigen1:"
    my variable Verleihstatus
    puts "Titel: $Titel, Zustand: $Zustand, Status: $Verleihstatus, Autor: $Autor, ISBN: $ISBN"
  }

  method BuchAnzeigen2 {} {
    puts "BuchAnzeigen2:"
    my Anzeigen
    puts "Autor: $Autor, ISBN: $ISBN"
  }

  export BuchAnzeigen1
  export BuchAnzeigen2
}

set Buch1 [Buchobjekt new "Erstes Buch" "gut" "Scholl" "123-456-789"]

$Buch1 Anzeigen
$Buch1 BuchAnzeigen1
$Buch1 BuchAnzeigen2
