#!/usr/bin/env tclsh

oo::class create KlasseBuecherei {
  variable Titel

  constructor {tmpTitel} {
    set Titel $tmpTitel
  }
  
  method Anzeigen {} {
    puts "Titel: $Titel"
  }

  export Anzeigen
}

oo::class create KlasseAusleihe {
  variable Rueckgabedatum
  
  method SetzeRueckgabedatum {tmpDatum} {
    set Rueckgabedatum $tmpDatum
  }

  method ZeigeRueckgabedatum {} {
    puts "Rueckgabe bis: $Rueckgabedatum"
  }
  
  export SetzeRueckgabedatum
  export ZeigeRueckgabedatum
}

oo::class create KlasseBuch {
  superclass KlasseBuecherei
  mixin KlasseAusleihe

  variable Titel
  variable ISBN

  method SetzeISBN {tmpISBN} {
    set ISBN $tmpISBN
  }
  
  method Anzeigen {} {
    next
    puts "ISBN: $ISBN"
	my ZeigeRueckgabedatum
  }
  
  export SetzeISBN
  export Anzeigen
}

oo::class create KlasseDVD {
  superclass KlasseBuecherei
  mixin KlasseAusleihe

  variable Titel
  variable EAN

  method SetzeEAN {tmpEAN} {
    set EAN $tmpEAN
  }

  method Anzeigen {} {
    next
    puts "EAN: $EAN"
	my ZeigeRueckgabedatum
  }

  export SetzeEAN
  export Anzeigen
}

oo::class create KlasseZeitschrift {
  superclass KlasseBuecherei
 
  variable Titel
  variable Heftnummer
  
  method SetzeHeftnummer {tmpHeftnummer} {
    set Heftnummer $tmpHeftnummer
  }

  method Anzeigen {} {
    next
    puts "Heftnummer: $Heftnummer"
  }

  export SetzeHeftnummer
  export Anzeigen
}

KlasseBuch create Buch1 "Mein Buch"
KlasseDVD create DVD1 "Meine DVD"
KlasseZeitschrift create Zeitschrift1 "Meine Zeitschrift"

Buch1 SetzeISBN "123-456-789"
DVD1 SetzeEAN "555243579"
Zeitschrift1 SetzeHeftnummer "5/2015"

Buch1 SetzeRueckgabedatum "17.08.2015"
DVD1 SetzeRueckgabedatum "11.08.2015"

Buch1 Anzeigen
puts ""
DVD1 Anzeigen
puts ""
Zeitschrift1 Anzeigen
