#!/usr/bin/env wish

# erzeugt einen Rahmen, der die Zeichenflaeche und die Scroll-Leisten zusammenfasst
ttk::frame .frAlles

# erzeugt die Zeichenflaeche
canvas .frAlles.c -width 400 -height 200 -xscrollcommand ".frAlles.xscroll set" -yscrollcommand ".frAlles.yscroll set"
ttk::scrollbar .frAlles.xscroll -orient horizontal -command ".frAlles.c xview"
ttk::scrollbar .frAlles.yscroll -command ".frAlles.c yview"
pack .frAlles.xscroll -side bottom -fill x
pack .frAlles.yscroll -side right -fill y
pack .frAlles.c -expand yes -fill both -side top

# erzeugt einen Rahmen mit allen Widgets
ttk::frame .frAlles.c.frWidgets -borderwidth 1 -relief solid -width 340 -height 700
for {set i 0} {$i <=20} {incr i} {
  ttk::label .frAlles.c.frWidgets.lb$i -text "Label $i:"
  ttk::entry .frAlles.c.frWidgets.en$i
  ttk::button .frAlles.c.frWidgets.bt$i -text "Button $i" -command exit
  grid .frAlles.c.frWidgets.lb$i -padx 2 -pady 2 -row $i -column 0 
  grid .frAlles.c.frWidgets.en$i -padx 2 -pady 2 -row $i -column 1
  grid .frAlles.c.frWidgets.bt$i -padx 2 -pady 2 -row $i -column 2 
}

# platziert den Rahmen mit den Widgets
.frAlles.c create window 0 0 -anchor nw -window .frAlles.c.frWidgets 

# ermittelt die tatsaechliche Groesse der Zeichenflaeche
.frAlles.c configure -scrollregion [.frAlles.c bbox all]

# erzeugt einen Rahmen mit allen Buttons, die fuer den gesamten Dialog gelten
ttk::frame .frButtons 
ttk::button .frButtons.btOK -text "OK" -command exit
ttk::button .frButtons.btAbbruch -text "Abbruch" -command exit
pack .frButtons.btOK -padx 2 -pady 2 -side left
pack .frButtons.btAbbruch -padx 2 -pady 2 -side left

# zeigt den Rahmen mit der Zeichenflaeche an und die Buttons zum Dialog
pack .frAlles -expand yes -fill both -side top
pack .frButtons -side bottom
