#!/usr/bin/env wish

set Konf(Skriptname) [info script]
if {[file type $Konf(Skriptname)] == "link"} {
	set Konf(Skriptname) [file readlink $Konf(Skriptname)]
}

set Konf(Bild) [file join [file dirname $Konf(Skriptname)] foto2.ppm]

proc SichtbarerBildteil {BildBreite BildHoehe} {
	# ermittelt die sichtbare Breite und Hoehe des Bildes (in Pixel)
	# Rueckgabe: eine Liste bestehend aus der sichtbaren Breite und der sichtbaren Hoehe
	set tmp [.fr.c xview]
	set tmp1 [lindex $tmp 0]
	set tmp2 [lindex $tmp 1]
	set Breite [expr round(1.0*($tmp2 - $tmp1) * $BildBreite)]

	set tmp [.fr.c yview]
	set tmp1 [lindex $tmp 0]
	set tmp2 [lindex $tmp 1]
	set Hoehe [expr round(1.0*($tmp2 - $tmp1) * $BildHoehe)]
	
	set Rueckgabe ""
	lappend Rueckgabe $Breite
	lappend Rueckgabe $Hoehe
	return $Rueckgabe
}

proc BildZentrieren {x y BildBreite BildHoehe} {
	# Verschiebt das Bild, so dass die Bild-Koordinate x/y in der Mitte des sichtbaren Fensters ist

	set tmp [SichtbarerBildteil $BildBreite $BildHoehe]
	set FensterBreite [lindex $tmp 0]
	set FensterHoehe [lindex $tmp 1]

	set xMittelpunkt [expr max(1.0*($x - $FensterBreite/2)/$BildBreite,0)]
	set yMittelpunkt [expr max(1.0*($y - $FensterHoehe/2)/$BildHoehe,0)]
	.fr.c xview moveto $xMittelpunkt
	.fr.c yview moveto $yMittelpunkt
}

proc PunktZeichnen {x y Radius Farbe Dicke} {
	# x/y = Bild-Koordinaten
	set x1 [expr max($x-$Radius,0)]
	set x2 [expr $x+$Radius]
	set y1 [expr max($y-$Radius,0)]
	set y2 [expr $y+$Radius]
	set ID [.fr.c create oval $x1 $y1 $x2 $y2 -width $Dicke -outline $Farbe -fill $Farbe]
	return $ID
}

proc FindeItem {x y} {
   set x [.fr.c canvasx $x]
   set y [.fr.c canvasy $y]
   set ID [.fr.c find closest $x $y]
   return $ID
}

ttk::frame .fr
canvas .fr.c -width 100 -height 150 -xscrollcommand ".fr.xscroll set" -yscrollcommand ".fr.yscroll set"

set Bild2 [image create photo Bild -file $Konf(Bild)]
set BildBreite [image width $Bild2] 
set BildHoehe [image height $Bild2] 

.fr.c create image 0 0 -anchor nw -image Bild
.fr.c configure -scrollregion [.fr.c bbox all]
ttk::scrollbar .fr.xscroll -orient horizontal -command ".fr.c xview"
ttk::scrollbar .fr.yscroll -command ".fr.c yview"
pack .fr.xscroll -side bottom -fill x
pack .fr.yscroll -side right -fill y
pack .fr.c -expand yes -fill both -side top
pack .fr -expand yes -fill both -side top
bind .fr.c <ButtonRelease-1> {puts "Fensterkoordinaten: %x / %y    Bildkoordinaten: [%W canvasx %x] / [%W canvasy %y]"}
bind .fr.c <Shift-ButtonRelease-1> {set ID [FindeItem %x %y];.fr.c moveto $ID 40 60}
bind .fr.c <Control-ButtonRelease-1> {set ID [FindeItem %x %y];.fr.c moveto $ID 20 40}
bind .fr.c <ButtonRelease-3> {BildZentrieren 100 133 $BildBreite $BildHoehe}

set ID [PunktZeichnen 20 40 10 red 4]
# Das Bild ist 200 Pixel breit und 266 Pixel hoch
set MittelpunktID [PunktZeichnen 100 133 5 yellow 2]
