#!/usr/bin/env tclsh

package require struct::matrix

::struct::matrix MeineMatrix

MeineMatrix add columns 5

set Zeile1 {01 02 03 04 05}
set Zeile2 {21 22 23 24 25}
MeineMatrix add row $Zeile1
MeineMatrix add row $Zeile2

set Zeile3 {11 12 13 14 15}
MeineMatrix insert row 1 $Zeile3

puts "Matrix anzeigen:"
set Zeilen [MeineMatrix rows]
for {set Zeile 0} {$Zeile < $Zeilen} {incr Zeile} {
    puts [MeineMatrix get row $Zeile]
}
set Spalten [MeineMatrix columns]
set Zeilen [MeineMatrix rows]
puts ""
puts "Die Matrix hat $Zeilen Zeilen und $Spalten Spalten."
puts "In der Zelle in Zeile 3, Spalte 4 steht:"
puts [MeineMatrix get cell 3 2]

puts "--------------------"
puts "Die Zeilen der Matrix nach Spalte 2 absteigend sortieren:"
set MeineMatrix [MeineMatrix sort rows -decreasing 1]
set Zeilen [MeineMatrix rows]
for {set Zeile 0} {$Zeile < $Zeilen} {incr Zeile} {
    puts [MeineMatrix get row $Zeile]
}
set MeineMatrix [MeineMatrix sort rows -increasing 1]

puts "--------------------"
puts "Die Spalten der Matrix nach Zeile 2 absteigend sortieren:"
set MeineMatrix [MeineMatrix sort columns -decreasing 1]
set Zeilen [MeineMatrix rows]
for {set Zeile 0} {$Zeile < $Zeilen} {incr Zeile} {
    puts [MeineMatrix get row $Zeile]
}
set MeineMatrix [MeineMatrix sort columns -increasing 1]

puts "--------------------"
puts "Die 1. und 2. Spalte der Matrix vertauschen:"
set MeineMatrix [MeineMatrix swap columns 0 1]
set Zeilen [MeineMatrix rows]
for {set Zeile 0} {$Zeile < $Zeilen} {incr Zeile} {
    puts [MeineMatrix get row $Zeile]
}
set MeineMatrix [MeineMatrix swap columns 1 0]

puts "--------------------"
puts "Die 1. und 2. Zeile der Matrix vertauschen:"
set MeineMatrix [MeineMatrix swap rows 0 1]
set Zeilen [MeineMatrix rows]
for {set Zeile 0} {$Zeile < $Zeilen} {incr Zeile} {
    puts [MeineMatrix get row $Zeile]
}
set MeineMatrix [MeineMatrix swap rows 1 0]

puts "--------------------"
puts "Die Spalten der Matrix anzeigen:"
set Spalten [MeineMatrix columns]
for {set Spalte 0} {$Spalte < $Spalten} {incr Spalte} {
    puts [MeineMatrix get column $Spalte]
}

puts "--------------------"
puts "Die Zelle in Zeile 3, Spalte 4 aendern."
MeineMatrix set cell 3 2 999
for {set Zeile 0} {$Zeile < $Zeilen} {incr Zeile} {
    puts [MeineMatrix get row $Zeile]
}

puts "--------------------"
puts "Folgende Matrix nach dem Wert 999 durchsuchen:"
MeineMatrix set cell 4 1 999
set Zeilen [MeineMatrix rows]
for {set Zeile 0} {$Zeile < $Zeilen} {incr Zeile} {
    puts [MeineMatrix get row $Zeile]
}
puts ""
set Suchbegriff 999
set TrefferListe [MeineMatrix search -exact all $Suchbegriff]
set AnzahlTreffer [llength $TrefferListe]
for {set Zaehler 0} {$Zaehler < $AnzahlTreffer} {incr Zaehler} {
	set Spaltenindex [lindex [lindex $TrefferListe $Zaehler] 0]
	set Zeilenindex [lindex [lindex $TrefferListe $Zaehler] 1]
	puts "Der Wert $Suchbegriff ist in Zeilenindex $Zeilenindex und Spalteindex $Spaltenindex."
}

puts "--------------------"
MeineMatrix delete row 1
puts "Nachdem die 2. Zeile wurde geloescht:"
set Zeilen [MeineMatrix rows]
for {set Zeile 0} {$Zeile < $Zeilen} {incr Zeile} {
    puts [MeineMatrix get row $Zeile]
}
