#!/usr/bin/env wish

package require Tktable
package require struct::matrix

proc Sortieren {Richtung Spalte} {
  set Titelzeile [MeineMatrix get row 0]
  MeineMatrix delete row 0
  MeineMatrix sort rows $Richtung $Spalte
  MeineMatrix insert row 0 $Titelzeile
}

::struct::matrix MeineMatrix

MeineMatrix add columns 40

for {set Spalte 0} {$Spalte < 40} {incr Spalte} {
  lappend Werte "Spalte $Spalte"
}
MeineMatrix add row $Werte

for {set Zeile 1} {$Zeile < 100} {incr Zeile} {
  set Werte {}
  for {set Spalte 0} {$Spalte < 40} {incr Spalte} {
    lappend Werte [expr ($Zeile - 1) *40 + $Spalte + 1]
  }
  MeineMatrix add row $Werte
}

ttk::frame .fr

table .fr.table \
  -rows 1 \
  -cols 40 \
  -titlerows 1 \
  -titlecols 0 \
  -height 5 \
  -width 25 \
  -rowheight 1 \
  -colwidth 9 \
  -maxheight 100 \
  -maxwidth 400 \
  -selectmode extended \
  -variable Tabellenwerte \
  -xscrollcommand {.fr.xscroll set} \
  -yscrollcommand {.fr.yscroll set}
  
scrollbar .fr.xscroll -command {.fr.table xview} -orient horizontal
scrollbar .fr.yscroll -command {.fr.table yview}

pack .fr -fill both -expand 1
pack .fr.xscroll -side bottom -fill x
pack .fr.yscroll -side right -fill y
pack .fr.table -side right -fill both -expand 1

ttk::button .btAufsteigend -text "Aufsteigend" -command {Sortieren "-increasing" 2}
ttk::button .btAbsteigend -text "Absteigend" -command {Sortieren "-decreasing" 2}
pack .btAufsteigend -side left
pack .btAbsteigend -side left

MeineMatrix link -transpose Tabellenwerte
.fr.table configure -rows [MeineMatrix rows]
