#!/usr/bin/env tclsh

proc DateienFinden {Startordner} {
  set Liste ""

  # Dateien
  foreach Element [glob -nocomplain -types f -directory $Startordner *] {
    if {[file tail $Element] ni {. ..}} {
	  lappend Liste $Element
	}
  }

  foreach Element [glob -nocomplain -types {f hidden} -directory $Startordner *] {
    if {[file tail $Element] ni {. ..}} {
      lappend Liste $Element
    }
  }

  # Ordner
  foreach Element [glob -nocomplain -types d -directory $Startordner *] {
    if {[file tail $Element] ni {. ..}} {
      lappend Liste $Element
      set Dateien [DateienFinden $Element]
      set Liste [concat $Liste $Dateien]
    }
  }

  foreach Element [glob -nocomplain -types {d hidden} -directory $Startordner *] {
    if {[file tail $Element] ni {. ..}} {
      lappend Liste $Element
      set Dateien [DateienFinden $Element ]
      set Liste [concat $Liste $Dateien]
    }
  }

  set Liste [lsort -dictionary -unique $Liste]
  return $Liste
}

set Startordner [file join $env(HOME) test]
set Liste [DateienFinden $Startordner]
foreach Element $Liste {
  puts $Element
}

