#!/usr/bin/env wish

proc EintragAendern {Liste Eintrag} {
  set ID [lindex $Liste $Eintrag]
  .frOben.tv item $ID -values {"Neuer Text"}
  update idletasks
}

proc EintragLoeschen {Liste Eintrag} {
  set ID [lindex $Liste $Eintrag]
  .frOben.tv delete $ID
  update idletasks

  # ID-Liste anpassen
  set AnzahlElemente [llength $Liste]
  if {$Eintrag == 0} {
    set Liste [lrange $Liste 1 end]
  } elseif {$Eintrag == [expr $AnzahlElemente - 1]} {
    set Liste [lrange $Liste 0 end-1]
  } else {
    set Liste [concat [lrange $Liste 0 [expr $Eintrag - 1]] [lrange $Liste [expr $Eintrag + 1] end]]
  }
  return $Liste
}

proc AllesLoeschen {} {
	set Eintraege [.frOben.tv children {}]
	foreach i $Eintraege {
		.frOben.tv delete $i
	}
	return {}
}

set Liste {Anton Berta Caesar Dora Emil}

set ListeTreeviewID {}
ttk::frame .frOben
ttk::treeview .frOben.tv -columns Person -show headings -yscrollcommand {.frOben.sbY set}
foreach Element $Liste {
  set ID [.frOben.tv insert {} end -values $Element]
  lappend ListeTreeviewID $ID
}
ttk::scrollbar .frOben.sbY -command {.frOben.tv yview}

pack .frOben.sbY -side right -fill y
pack .frOben.tv -side left -expand yes -fill both

ttk::frame .frUnten
ttk::button .frUnten.btAendern -text "Eintrag aendern" -command {EintragAendern $ListeTreeviewID 2}
ttk::button .frUnten.btLoeschen -text "Eintrag loeschen" -command {set ListeTreeviewID [EintragLoeschen $ListeTreeviewID 2]}
ttk::button .frUnten.btAllesLoeschen -text "Alles loeschen" -command {set ListeTreeviewID [AllesLoeschen]}
pack .frUnten.btAendern -side left
pack .frUnten.btLoeschen -side left
pack .frUnten.btAllesLoeschen -side left

pack .frOben -side top -expand yes -fill both
pack .frUnten -side bottom
