#!/usr/bin/env tclsh

package require sqlite3

set Datenbank [file join [file dirname [info script]] MeineDB] ; # entfaellt, wenn die Datenbank im Arbeitsspeicher gehalten wird

proc DatenbankErstellen {} {
  global db

  for {set i 1} {$i <= 3} {incr i} {
 	  db eval "create table tmpTabelle$i ( \
		ID integer primary key autoincrement, \
		Name text
	  )"
  }
}

proc DatenbankOeffnen {} {
  global Datenbank
  global db
  if {[file exist $Datenbank] == 0} {
    # Datenbank existiert nicht
    sqlite3 db $Datenbank ; # Alternativ: sqlite3 db ":memory:"
    DatenbankErstellen
  } else {
    # Datenbank existiert
    sqlite3 db $Datenbank
  }
}

proc DatenbankSchliessen {} {
  global db
  catch db close
}

# Hauptprogramm

DatenbankOeffnen

db eval {insert into tmpTabelle1 values(NULL,"Anton")}
db eval {insert into tmpTabelle1 values(NULL,"Berta")}
db eval {insert into tmpTabelle2 values(NULL,"Caesar")}
db eval {insert into tmpTabelle3 values(NULL,"Dora")}

for {set i 1} {$i <= 3} {incr i} {
	puts "Tabelle $i:"
	puts [db eval "select * from tmpTabelle$i"]
	puts "----"
}

DatenbankSchliessen

file delete -force $Datenbank
