#!/usr/bin/env wish

package require Tktable

proc NachObenScrollen {} {
	set Koordinaten [split [.fr.table index topleft] ","]
	set Zeile [lindex $Koordinaten 0]
	
	if {$Zeile >= 10} {
		incr Zeile -10
	} else {
		set Zeile 0
	}
	
	.fr.table yview $Zeile
	update idletasks
	puts [.fr.table index topleft]
}

proc NachUntenScrollen {} {
	set Koordinaten [split [.fr.table index topleft] ","]
	set Zeile [lindex $Koordinaten 0]
	
	incr Zeile 10
	
	.fr.table yview $Zeile
	update idletasks
	puts [.fr.table index topleft]
}

ttk::frame .fr

table .fr.table \
  -rows 1000 \
  -cols 100 \
  -titlerows 1 \
  -titlecols 0 \
  -height 20 \
  -width 25 \
  -rowheight 1 \
  -colwidth 9 \
  -maxheight 300 \
  -maxwidth 400 \
  -selectmode extended \
  -variable Wert \
  -xscrollcommand {.fr.xscroll set} \
  -yscrollcommand {.fr.yscroll set} \
  -state disabled
  
ttk::scrollbar .fr.xscroll -command {.fr.table xview} -orient horizontal
ttk::scrollbar .fr.yscroll -command {.fr.table yview}

pack .fr -fill both -expand 1
pack .fr.xscroll -side bottom -fill x
pack .fr.yscroll -side right -fill y
pack .fr.table -side right -fill both -expand 1
  
for {set Zeile 0} {$Zeile <= 1000} {incr Zeile} {
  for {set Spalte 0} {$Spalte <= 100} {incr Spalte} {
    set Wert($Zeile,$Spalte) "Z$Zeile S$Spalte"
  }
}

.fr.table xview 0
.fr.table yview 0
update idletasks
puts [.fr.table index topleft]

# Bindings
bind .fr.yscroll <ButtonRelease-1> {puts [.fr.table index topleft]}
bind .fr.xscroll <ButtonRelease-1> {puts [.fr.table index topleft]}
bind .fr.table <KeyRelease-Prior> {puts [.fr.table index topleft]}
bind .fr.table <KeyRelease-Next> {puts [.fr.table index topleft]}

bind .fr.table <KeyRelease-Up> {puts [.fr.table index topleft]}
bind .fr.table <KeyRelease-Down> {puts [.fr.table index topleft]}
bind .fr.table <KeyRelease-Left> {puts [.fr.table index topleft]}
bind .fr.table <KeyRelease-Right> {puts [.fr.table index topleft]}

bind .fr.table <KeyRelease-Home> {puts [.fr.table index topleft]}
bind .fr.table <KeyRelease-End> {puts [.fr.table index topleft]}

# Scrollrad der Maus
bind .fr.table <Button-4> {NachObenScrollen}
bind .fr.table <Button-5> {NachUntenScrollen}

# Fokus auf die Tabelle setzen, damit die Tabelle direkt auf die Tasten reagiert
focus .fr.table

