#!/usr/bin/env wish

package require Tktable

ttk::frame .fr

table .fr.table \
  -rows 1000 \
  -cols 100 \
  -titlerows 1 \
  -titlecols 0 \
  -height 20 \
  -width 25 \
  -rowheight 1 \
  -colwidth 9 \
  -maxheight 300 \
  -maxwidth 400 \
  -selectmode extended \
  -variable Wert \
  -xscrollcommand {.fr.xscroll set} \
  -yscrollcommand {.fr.yscroll set} \
  -state disabled
  
scrollbar .fr.xscroll -command {.fr.table xview} -orient horizontal
scrollbar .fr.yscroll -command {.fr.table yview}

pack .fr -fill both -expand 1
pack .fr.xscroll -side bottom -fill x
pack .fr.yscroll -side right -fill y
pack .fr.table -side right -fill both -expand 1
  
for {set Zeile 0} {$Zeile <= 1000} {incr Zeile} {
  for {set Spalte 0} {$Spalte <= 100} {incr Spalte} {
    set Wert($Zeile,$Spalte) "Z$Zeile S$Spalte"
  }
}

.fr.table xview 0
.fr.table yview 0
update idletasks
puts "Sichtbare Zelle links oben: [.fr.table index topleft]"
puts "Sichtbare Zelle rechts unten: [.fr.table index bottomright]"
puts "Zelle rechts unten am Tabellenende: [.fr.table index end]"

