#!/usr/bin/env tclsh

oo::class create Figur {
  variable Name
  variable Flaeche

  constructor {tmpName} {
    set Name $tmpName
    set Flaeche "unbekannt"
  }

  method Anzeigen {} {
    puts "$Name: Flaeche=$Flaeche"
  }
	
  export Anzeigen
}

oo::class create Filter {
  variable SeiteA
  variable SeiteB

  method WertePruefen {args} {
    if {$SeiteA < 0 || $SeiteB < 0} {
	  puts "Die Werte werden korrigiert."
	  set SeiteA 0
	  set SeiteB 0
    } 
	return [next {*}$args]
  }

  unexport WertePruefen
}

oo::class create Rechteck {
  superclass Figur
  mixin Filter
  
  variable Flaeche
  variable SeiteA
  variable SeiteB
  
  filter WertePruefen
  
  constructor {tmpName tmpSeiteA tmpSeiteB} {
    next $tmpName
    set SeiteA $tmpSeiteA
    set SeiteB $tmpSeiteB
  }
  
  method Flaeche {Anteil} {
    set Flaeche [expr 1.0 * $SeiteA * $SeiteB * $Anteil]
  }
  
  export Flaeche
}

Rechteck create Rechteck1 "Rechteck1" 3 5
Rechteck1 Anzeigen
Rechteck1 Flaeche 0.5
Rechteck1 Anzeigen

