#!/usr/bin/env wish

set Farbe1 #0058A2 ; # dunkelblau
set Farbe2 #68A2D4 ; # mittelblau
set Farbe3 #DEE8F7 ; # hellblau
set Farbe4 #FFFFFF ; # weiss
set Farbe6 #D0D0D0 ; # hellgrau
set Farbe7 #A0A0A0 ; # mittelgrau
set Farbe8 #707070 ; # dunkelgrau
set Farbe10 #000000 ; # schwarz

font create MeineSchrift -family Helvetica -size 12 -slant roman -weight normal

ttk::style theme use clam

ttk::style configure MeinStil.TSpinbox -fieldbackground $Farbe2
ttk::style configure MeinStil.TSpinbox -bordercolor $Farbe1
ttk::style configure MeinStil.TSpinbox -lightcolor $Farbe2
ttk::style configure MeinStil.TSpinbox -darkcolor $Farbe2
ttk::style configure MeinStil.TSpinbox -arrowsize 13
ttk::style configure MeinStil.TSpinbox -font MeineSchrift

ttk::style configure MeinStil.TSpinbox -background $Farbe2
ttk::style configure MeinStil.TSpinbox -foreground $Farbe1
ttk::style configure MeinStil.TSpinbox -arrowcolor $Farbe1

ttk::style configure MeinStil.TSpinbox -insertcolor $Farbe1 ; # Cursorfarbe
ttk::style configure MeinStil.TSpinbox -selectbackground $Farbe1
ttk::style configure MeinStil.TSpinbox -selectforeground $Farbe2

ttk::style map MeinStil.TSpinbox -background [list active $Farbe2 disabled $Farbe7 readonly $Farbe4]
ttk::style map MeinStil.TSpinbox -foreground [list active $Farbe2 disabled $Farbe8 readonly $Farbe10]
ttk::style map MeinStil.TSpinbox -bordercolor [list active $Farbe2 disabled $Farbe8 readonly $Farbe4]
ttk::style map MeinStil.TSpinbox -lightcolor [list active $Farbe1 disabled $Farbe7 readonly $Farbe10]
ttk::style map MeinStil.TSpinbox -darkcolor [list active $Farbe1 disabled $Farbe7 readonly $Farbe10]
ttk::style map MeinStil.TSpinbox -arrowcolor [list active $Farbe1 disabled $Farbe8 readonly $Farbe10]
ttk::style map MeinStil.TSpinbox -fieldbackground [list active $Farbe2 disabled $Farbe7 readonly $Farbe4]

ttk::style configure Disabled.MeinStil.TSpinbox
ttk::style map Disabled.MeinStil.TSpinbox -background [list active $Farbe7 disabled $Farbe7]
ttk::style map Disabled.MeinStil.TSpinbox -foreground [list active $Farbe8 disabled $Farbe8]
ttk::style map Disabled.MeinStil.TSpinbox -bordercolor [list active $Farbe8 disabled $Farbe8]
ttk::style map Disabled.MeinStil.TSpinbox -lightcolor [list active $Farbe7 disabled $Farbe7]
ttk::style map Disabled.MeinStil.TSpinbox -darkcolor [list active $Farbe7 disabled $Farbe7]
ttk::style map Disabled.MeinStil.TSpinbox -arrowcolor [list active $Farbe8 disabled $Farbe8]
ttk::style map Disabled.MeinStil.TSpinbox -fieldbackground [list active $Farbe7 disabled $Farbe7]

ttk::style configure Readonly.MeinStil.TSpinbox
ttk::style configure Readonly.MeinStil.TSpinbox -insertcolor $Farbe4
ttk::style configure Readonly.MeinStil.TSpinbox -selectbackground $Farbe4
ttk::style configure Readonly.MeinStil.TSpinbox -selectforeground $Farbe10
ttk::style map Readonly.MeinStil.TSpinbox -background [list active $Farbe4 readonly $Farbe4]
ttk::style map Readonly.MeinStil.TSpinbox -foreground [list active $Farbe10 readonly $Farbe10]
ttk::style map Readonly.MeinStil.TSpinbox -bordercolor [list active $Farbe4 readonly $Farbe4]
ttk::style map Readonly.MeinStil.TSpinbox -lightcolor [list active $Farbe10 readonly $Farbe10]
ttk::style map Readonly.MeinStil.TSpinbox -darkcolor [list active $Farbe10 readonly $Farbe10]
ttk::style map Readonly.MeinStil.TSpinbox -arrowcolor [list active $Farbe10 readonly $Farbe10]
ttk::style map Readonly.MeinStil.TSpinbox -fieldbackground [list active $Farbe4 readonly $Farbe4]

set Liste {Januar Februar Maerz April Mai Juni}
set Monat [lindex $Liste 0]
ttk::spinbox .sb -values $Liste -textvariable Monat -state normal -style MeinStil.TSpinbox -font MeineSchrift
pack .sb -side left

ttk::button .btKlein -text "Schrift 8" -command {font configure MeineSchrift -size 8; ttk::style configure MeinStil.TSpinbox -arrowsize 11; set Monat $Monat}
ttk::button .btGross -text "Schrift 16" -command {font configure MeineSchrift -size 16; ttk::style configure MeinStil.TSpinbox -arrowsize 15; set Monat $Monat}
pack .btKlein -side top
pack .btGross -side top

ttk::button .btNormal -text "Normal" -command {.sb configure -state normal; .sb configure -style MeinStil.TSpinbox}
ttk::button .btReadonly -text "Readonly" -command {.sb configure -state readonly; .sb configure -style Readonly.MeinStil.TSpinbox}
ttk::button .btDisabled -text "Disabled" -command {.sb configure -state disabled; .sb configure -style Disabled.MeinStil.TSpinbox}
pack .btNormal -side top
pack .btReadonly -side top
pack .btDisabled -side top
