#!/usr/bin/env wish

set Farbe1 #0058A2 ; # dunkelblau
set Farbe2 #68A2D4 ; # mittelblau
set Farbe3 #DEE8F7 ; # hellblau
set Farbe4 #FFFFFF ; # weiss
set Farbe6 #D0D0D0 ; # hellgrau
set Farbe7 #A0A0A0 ; # mittelgrau
set Farbe8 #707070 ; # dunkelgrau
set Farbe10 #000000 ; # schwarz

font create MeineSchrift -family Helvetica -size 12 -slant roman -weight normal

ttk::style theme use clam

ttk::style configure MeinStil.TCombobox -background $Farbe2
ttk::style configure MeinStil.TCombobox -foreground $Farbe1
ttk::style configure MeinStil.TCombobox -fieldbackground $Farbe3
ttk::style configure MeinStil.TCombobox -arrowcolor $Farbe1
ttk::style configure MeinStil.TCombobox -arrowsize 16
ttk::style configure MeinStil.TCombobox -selectbackground $Farbe1
ttk::style configure MeinStil.TCombobox -selectforeground $Farbe3
ttk::style configure MeinStil.TCombobox -insertcolor $Farbe1
ttk::style configure MeinStil.TCombobox -font MeineSchrift

ttk::style map MeinStil.TCombobox -background [list disabled $Farbe6 readonly $Farbe2]
ttk::style map MeinStil.TCombobox -foreground [list disabled $Farbe8 readonly $Farbe1]
ttk::style map MeinStil.TCombobox -fieldbackground [list disabled $Farbe6 readonly $Farbe3]
ttk::style map MeinStil.TCombobox -arrowcolor [list disabled $Farbe8 readonly $Farbe1]

# die Scrollbars innerhalb der Combobox
ttk::style configure Vertical.TScrollbar -background $Farbe2
ttk::style configure Vertical.TScrollbar -lightcolor $Farbe1
ttk::style configure Vertical.TScrollbar -darkcolor $Farbe2
ttk::style configure Vertical.TScrollbar -troughcolor $Farbe3
ttk::style configure Vertical.TScrollbar -arrowcolor $Farbe1
ttk::style configure Vertical.TScrollbar -arrowsize 12

ttk::style map Vertical.TScrollbar -background [list active $Farbe2 disabled $Farbe4]

# fuer die aufgeklappte Comobox gilt:
option add *TCombobox*Listbox.font MeineSchrift
option add *TCombobox*Listbox.background $Farbe3
option add *TCombobox*Listbox.foreground $Farbe1
option add *TCombobox*Listbox.selectBackground $Farbe1
option add *TCombobox*Listbox.selectForeground $Farbe3

set Liste {Anton Berta Caesar Dora Emil Friedrich Gustav Heinrich Ida Julius Kaufmann Ludwig Martha Nordpol Otto Paula Quelle Richard Samuel Theodor Ulrich Viktor Wilhelm Xanthippe Ypsilon Zacharias}
set Auswahl [lindex $Liste 0]
ttk::combobox .cb -values $Liste -textvariable Auswahl -font MeineSchrift -style MeinStil.TCombobox
pack .cb -side left

ttk::button .btKlein -text "Schrift 8" -command {
  font configure MeineSchrift -size 8
  ttk::style configure MeinStil.TCombobox -arrowsize 12
  ttk::style configure Vertical.TScrollbar -arrowsize 10
  set Auswahl $Auswahl
}
ttk::button .btGross -text "Schrift 16" -command {
  font configure MeineSchrift -size 16
  ttk::style configure MeinStil.TCombobox -arrowsize 20
  ttk::style configure Vertical.TScrollbar -arrowsize 18
  set Auswahl $Auswahl
}
pack .btKlein -side top
pack .btGross -side top

ttk::button .btNormal -text "Normal" -command {.cb configure -state normal}
ttk::button .btDisabled -text "Disabled" -command {.cb configure -state disabled}
ttk::button .btReadonly -text "Readonly" -command {.cb configure -state readonly}
pack .btNormal -side top
pack .btDisabled -side top
pack .btReadonly -side top
