#!/usr/bin/env wish

set Farbe1 #0058A2 ; # dunkelblau
set Farbe2 #68A2D4 ; # mittelblau
set Farbe3 #DEE8F7 ; # hellblau
set Farbe4 #FFFFFF ; # weiss
set Farbe6 #D0D0D0 ; # hellgrau
set Farbe7 #A0A0A0 ; # mittelgrau
set Farbe8 #707070 ; # dunkelgrau
set Farbe10 #000000 ; # schwarz

font create MeineSchrift -family Helvetica -size 12 -slant roman -weight normal

ttk::style theme use clam

ttk::style configure MeinStil.Treeview -background $Farbe2
ttk::style configure MeinStil.Treeview -foreground $Farbe1
ttk::style configure MeinStil.Treeview -fieldbackground $Farbe2
ttk::style configure MeinStil.Treeview -font MeineSchrift
ttk::style configure MeinStil.Treeview -rowheight 25

ttk::style map MeinStil.Treeview -background [list selected $Farbe1]
ttk::style map MeinStil.Treeview -foreground [list selected $Farbe2]

ttk::style configure MeinStil.Treeview.Heading -background $Farbe2
ttk::style configure MeinStil.Treeview.Heading -foreground $Farbe1
ttk::style configure MeinStil.Treeview.Heading -bordercolor $Farbe3
ttk::style configure MeinStil.Treeview.Heading -font MeineSchrift

ttk::style map MeinStil.Treeview.Heading -background [list active $Farbe1]
ttk::style map MeinStil.Treeview.Heading -foreground [list active $Farbe2]

ttk::style configure MeinStil.Treeview.Cell -padding [list 0 0 0 0]

set Dateien1 {{"Datei 1" "560" "16.07.2015"} {"Datei 2" "85" "25.04.2015"}}
set Dateien2 {{"Datei 3" "89" "03.11.2014"} {"Datei 4" "793" "15.08.2015"} {"Datei 5" "688" "30.11.2014"}}

ttk::treeview .tv -style MeinStil.Treeview -columns {Dateiname GroesseKB Datum} -yscrollcommand {.sbY set}

.tv column #0 -width 100
.tv column #1 -width 100
.tv column #2 -width 100
.tv column #3 -width 100

.tv heading #0 -text "Laufwerk"
.tv heading Dateiname -text "Dateiname"
.tv heading GroesseKB -text "GroesseKB"
.tv heading Datum -text "Datum"

.tv insert {} end -id Laufwerk1 -text "Laufwerk 1"
.tv insert {} end -id Laufwerk2 -text "Laufwerk 2"

foreach Element $Dateien1 {
  .tv insert Laufwerk1 end -values $Element
}

foreach Element $Dateien2 {
  .tv insert Laufwerk2 end -values $Element
}

ttk::scrollbar .sbY -command {.tv yview}

pack .sbY -side right -fill y
pack .tv -side left -expand yes -fill both

ttk::button .btKlein -text "Schrift 8" -command {
  font configure MeineSchrift -size 8
  ttk::style configure MeinStil.Treeview -rowheight 15
  .tv column #0 -width 80
  .tv column #1 -width 80
  .tv column #2 -width 80
  .tv column #3 -width 80
	
}
ttk::button .btGross -text "Schrift 16" -command {
  font configure MeineSchrift -size 16
  ttk::style configure MeinStil.Treeview -rowheight 35
  .tv column #0 -width 130
  .tv column #1 -width 130
  .tv column #2 -width 130
  .tv column #3 -width 130
}
pack .btKlein -side top
pack .btGross -side top
