#!/usr/bin/env tclsh
package require struct::matrix

expr srand([clock seconds])

::struct::matrix Matrix1
::struct::matrix Matrix2
Matrix1 add columns 5
Matrix2 add columns 5

for {set i 0} {$i < 2000} {incr i} {
	set tmp [expr int(100000*rand())]
	set Row [list $tmp $tmp $tmp $tmp $tmp]
	Matrix1 add row $Row
	Matrix2 add row $Row
}

set Sortierspalte 0

puts "Matrix1 sortieren:"
set Start [clock clicks -milliseconds]
set Matrix1 [Matrix1 sort rows -increasing $Sortierspalte]
set Zeit [expr [clock clicks -milliseconds] - $Start]
puts "Zeit: $Zeit ms"
puts "1. Zeile: [Matrix1 get row 0]"
puts "Letzte Zeile: [Matrix1 get row end]"
puts "---------------"

puts "Matrix2 mittels Liste sortieren:"
set Start [clock clicks -milliseconds]

set Liste {}
for {set i 0} {$i < [Matrix2 rows]} {incr i} {
	lappend Liste [Matrix2 get row $i]
}

if {[Matrix2 rows] > 0} {
	Matrix2 delete rows [expr [Matrix2 rows]]
}

set Liste [lsort -integer -increasing -index $Sortierspalte $Liste]

foreach Element $Liste {
	Matrix2 add row $Element
}

unset Liste

set Zeit [expr [clock clicks -milliseconds] - $Start]
puts "Zeit: $Zeit ms"
puts "1. Zeile: [Matrix2 get row 0]"
puts "Letzte Zeile: [Matrix2 get row end]"
