#!/usr/bin/env wish

package require Tktable

proc Sortieren {tmpVar Zeilen Spalten SortierSpalte} {
  upvar $tmpVar Tabelleninhalt

  set Liste {}
  for {set i 1} {$i < $Zeilen} {incr i} {
    set Zeilenwerte {}
    for {set j 0} {$j < $Spalten} {incr j} {
      lappend Zeilenwerte $Tabelleninhalt($i,$j)
    }
    lappend Liste $Zeilenwerte
  }

  set Liste [lsort -integer -increasing -index $SortierSpalte $Liste]

  for {set i 1} {$i < $Zeilen} {incr i} {
    set k [expr $i - 1]
    for {set j 0} {$j < $Spalten} {incr j} {
      set Tabelleninhalt($i,$j) [lindex [lindex $Liste $k] $j]
    }
  }
}

ttk::frame .fr

table .fr.table \
  -rows 10 \
  -cols 5 \
  -titlerows 1 \
  -titlecols 0 \
  -height 5 \
  -width 25 \
  -rowheight 1 \
  -colwidth 9 \
  -maxheight 100 \
  -maxwidth 400 \
  -selectmode extended \
  -variable Tabelleninhalt \
  -xscrollcommand {.fr.xscroll set} \
  -yscrollcommand {.fr.yscroll set}
  
ttk::scrollbar .fr.xscroll -command {.fr.table xview} -orient horizontal
ttk::scrollbar .fr.yscroll -command {.fr.table yview}

ttk::button .btSortieren -text "Sortieren" -command {Sortieren Tabelleninhalt [.fr.table cget -rows] [.fr.table cget -cols] 2}

pack .fr -fill both -expand 1
pack .fr.xscroll -side bottom -fill x
pack .fr.yscroll -side right -fill y
pack .fr.table -side right -fill both -expand 1
pack .btSortieren -side bottom
  
for {set Zeile 0} {$Zeile <= 9} {incr Zeile} {
  for {set Spalte 0} {$Spalte <= 4} {incr Spalte} {
    if {$Zeile == 0} {
      set Tabelleninhalt($Zeile,$Spalte) Titel$Spalte
    } else {
      set Tabelleninhalt($Zeile,$Spalte) [expr int(100*rand())]
    }
  }
}
