#!/usr/bin/env tclsh

package require struct::tree

::struct::tree Baum

# Es wird folgender Baum erfasst:
puts "root -+- Ordner A(0)"
puts "      +- Ordner B(1) -+- Ordner D(3) -+- Datei 3(6)"
puts "      |               |               +- Datei 4(7)"
puts "      |               +- Datei 1(4)"
puts "      |               +- Datei 2(5)"
puts "      +- Ordner C(2)"
puts "Der Index ist in Klammern gesetzt."
puts ""

# Unterhalb von root:
Baum insert root end 0
Baum set 0 Name "Ordner A"
Baum set 0 Typ "Ordner"

Baum insert root end 1
Baum set 1 Name "Ordner B"
Baum set 1 Typ "Ordner"

Baum insert root end 2
Baum set 2 Name "Ordner C"
Baum set 2 Typ "Ordner"

# Unterhalb von Ordner B:
Baum insert 1 end 3
Baum set 3 Name "Ordner D"
Baum set 3 Typ "Ordner"

Baum insert 1 end 4
Baum set 4 Name "Datei 1"
Baum set 4 Typ "Datei"

Baum insert 1 end 5
Baum set 5 Name "Datei 2"
Baum set 5 Typ "Datei"

# Unterhalb von Ordner D:
Baum insert 3 end 6
Baum set 6 Name "Datei 3"
Baum set 6 Typ "Datei"

Baum insert 3 end 7
Baum set 7 Name "Datei 4"
Baum set 7 Typ "Datei"

puts "Vorher:"
puts "Baum children -all root: [Baum children -all root]"

set Kinder [Baum children root]
foreach Kind $Kinder {
  Baum delete $Kind
}

puts "Nachher:"
puts "Baum children -all root: [Baum children -all root]"
