#!/usr/bin/env wish

proc Suchen {Widget Text} {
  # Durchsucht das Text-Widget nach einem Suchbegriff und markiert die Treffer
  $Widget tag remove Markierung 0.0 end
  set Laenge [string length $Text]
  set Liste [$Widget search -all $Text 1.0]
  set Zaehler 0
  set ErsterTreffer ""
  foreach Element $Liste {
    incr Zaehler
    if {$Zaehler == 1} {
      set ErsterTreffer $Element
    }
    set ZeileSpalte [split $Element "."]
    lassign $ZeileSpalte Zeile Spalte
    set Spalte [expr $Spalte + $Laenge]
    $Widget tag add Markierung $Element [string cat $Zeile "." $Spalte]
    $Widget tag configure Markierung -foreground red
  }
  if {$ErsterTreffer ne ""} {
    $Widget see $ErsterTreffer
  }
}

ttk::frame .frText
text .frText.tx -height 5 -width 15 -wrap word -xscrollcommand {.frText.sbX set} -yscrollcommand {.frText.sbY set}
ttk::scrollbar .frText.sbX -orient horizontal -command {.frText.tx xview}
ttk::scrollbar .frText.sbY -command {.frText.tx yview}

pack .frText.sbX -side bottom -fill x
pack .frText.sbY -side right -fill y
pack .frText.tx -side top -expand yes -fill both

ttk::frame .frSuchen
ttk::label .frSuchen.lbSuchen -text "Suchbegriff:"
ttk::entry .frSuchen.enSuchen -textvariable Suchbegriff 
ttk::button .frSuchen.btSuchen -text "Suchen" -command {Suchen .frText.tx $Suchbegriff}

pack .frSuchen.lbSuchen -side left
pack .frSuchen.enSuchen -side left
pack .frSuchen.btSuchen -side left

pack .frText -side top -expand yes -fill both
pack .frSuchen -side bottom 
